------------------------
---HideChatInviteSpam---
------------------------
--Novaspark-Firemaw EU (classic) / Venomisto-Frostmourne OCE (retail).
--https://www.curseforge.com/members/venomisto/projects
--Hides the "blocked invite" message from your chat window when a gold seller sends you channel invites.

--Set to true if you'd rather use the word filter instead of blocking all invite msgs.
local useFilter = false;

--Filter list, if enabled.
local filter = {
    "gold",
    "buy",
    "sell",
    "www",
    "usd",
    "euro",
    "com",
    "net",
    "org",
}

local lastInvite;
local function doFilter(self, event, msg, author, ...)
	if (not useFilter) then
		return true;
	end
	if (msg == "INVITE") then
		UIParentLoadAddOn('Blizzard_DebugTools') -- load debug tools
		if (not lastInvite) then
			return true;
		end
		for i, v in ipairs(filter) do
			if lastInvite:find(v) then
				return true;
			end
		end
    end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE_USER", doFilter)

local f = CreateFrame("Frame");
f:RegisterEvent("PLAYER_ENTERING_WORLD");
f:RegisterEvent("CHANNEL_INVITE_REQUEST");
f:SetScript('OnEvent', function(self, event, ...)
	if (event == "PLAYER_ENTERING_WORLD") then
		--Check cvar at login.
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		C_Timer.After(5, function()
			if (GetCVar("blockChannelInvites") ~= "1") then
				print("HideChatInviteSpam: You don't have channel invites disabled, this addon only blocks invite msgs "
				.. "if you have invites disabled in interface options -> social -> block chat channel invites.");
			end
		end)
	elseif (event == "CHANNEL_INVITE_REQUEST") then
		--Record last channel invite name, this event fires right before the chat filter.
		lastInvite = ...;
	end
end)